pcl::io::OrganizedPointCloudCompression< PointT > Class Template Reference

`#include <pcl/compression/organized_pointcloud_compression.h>`

## Public Types

using | PointCloud = pcl::PointCloud< PointT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr

## Public Member Functions

| OrganizedPointCloudCompression ()
| Empty Constructor. More...
virtual | ~OrganizedPointCloudCompression ()
| Empty deconstructor. More...
void | encodePointCloud (const PointCloudConstPtr &cloud_arg, std::ostream &compressedDataOut_arg, bool doColorEncoding=false, bool convertToMono=false, bool bShowStatistics_arg=true, int pngLevel_arg=-1)
| Encode point cloud to output stream. More...

void

encodeRawDisparityMapWithColorImage (std::vector< std::uint16_t > &disparityMap_arg, std::vector< std::uint8_t > &colorImage_arg, std::uint32_t width_arg, std::uint32_t height_arg, std::ostream &compressedDataOut_arg, bool doColorEncoding=false, bool convertToMono=false, bool bShowStatistics_arg=true, int pngLevel_arg=-1, float focalLength_arg=525.0f, float disparityShift_arg=174.825f, float disparityScale_arg=-0.161175f)

| Encode raw disparity map and color image. More...
bool | decodePointCloud (std::istream &compressedDataIn_arg, PointCloudPtr &cloud_arg, bool bShowStatistics_arg=true)
| Decode point cloud from input stream. More...

## Protected Member Functions

void | analyzeOrganizedCloud (PointCloudConstPtr cloud_arg, float &maxDepth_arg, float &focalLength_arg) const
| Analyze input point cloud and calculate the maximum depth and focal length. More...

## Detailed Description

### template<typename PointT>
class pcl::io::OrganizedPointCloudCompression< PointT >

Author
  Julius Kammerl (juliu.nosp@m.s@ka.nosp@m.mmerl.nosp@m..de)

Definition at line 60 of file organized_pointcloud_compression.h.

## Member Typedef Documentation

## PointCloud

template<typename PointT >

using pcl::io::OrganizedPointCloudCompression< PointT >::PointCloud = pcl::PointCloud<PointT>

Definition at line 63 of file organized_pointcloud_compression.h.

## PointCloudConstPtr

template<typename PointT >

using pcl::io::OrganizedPointCloudCompression< PointT >::PointCloudConstPtr = typename PointCloud::ConstPtr

Definition at line 65 of file organized_pointcloud_compression.h.

## PointCloudPtr

template<typename PointT >

using pcl::io::OrganizedPointCloudCompression< PointT >::PointCloudPtr = typename PointCloud::Ptr

Definition at line 64 of file organized_pointcloud_compression.h.

## Constructor & Destructor Documentation

## OrganizedPointCloudCompression()

template<typename PointT >

pcl::io::OrganizedPointCloudCompression< PointT >::OrganizedPointCloudCompression | ( |  | ) |

inline

Empty Constructor.

Definition at line 68 of file organized_pointcloud_compression.h.

## ~OrganizedPointCloudCompression()

template<typename PointT >

virtual pcl::io::OrganizedPointCloudCompression< PointT >::~OrganizedPointCloudCompression | ( |  | ) |

inline virtual

Empty deconstructor.

Definition at line 73 of file organized_pointcloud_compression.h.

## Member Function Documentation

## analyzeOrganizedCloud()

template<typename PointT >

void pcl::io::OrganizedPointCloudCompression< PointT >::analyzeOrganizedCloud | ( | PointCloudConstPtr | cloud_arg,
|  | float & | maxDepth_arg,
|  | float & | focalLength_arg
| ) |  | const

protected

Analyze input point cloud and calculate the maximum depth and focal length.

Parameters

  [in] | cloud_arg | input point cloud
  [out] | maxDepth_arg | calculated maximum depth
  [out] | focalLength_arg | estimated focal length

Definition at line 402 of file organized_pointcloud_compression.hpp.

References pcl::isFinite().

## decodePointCloud()

template<typename PointT >

bool pcl::io::OrganizedPointCloudCompression< PointT >::decodePointCloud | ( | std::istream & | compressedDataIn_arg,
|  | PointCloudPtr & | cloud_arg,
|  | bool | bShowStatistics_arg = `true`
| ) |  |

Decode point cloud from input stream.

Parameters

  [in] | compressedDataIn_arg | binary input stream containing compressed data
  [out] | cloud_arg | reference to decoded point cloud
  [in] | bShowStatistics_arg | show compression statistics during decoding

Returns
  false if an I/O error occurred.

Definition at line 275 of file organized_pointcloud_compression.hpp.

References pcl::io::decodePNGToImage().

## encodePointCloud()

template<typename PointT >

void pcl::io::OrganizedPointCloudCompression< PointT >::encodePointCloud | ( | const PointCloudConstPtr & | cloud_arg,
|  | std::ostream & | compressedDataOut_arg,
|  | bool | doColorEncoding = `false`,
|  | bool | convertToMono = `false`,
|  | bool | bShowStatistics_arg = `true`,
|  | int | pngLevel_arg = `-1`
| ) |  |

Encode point cloud to output stream.

Parameters

  [in] | cloud_arg | point cloud to be compressed
  [out] | compressedDataOut_arg | binary output stream containing compressed data
  [in] | doColorEncoding | encode color information (if available)
  [in] | convertToMono | convert rgb to mono
  [in] | pngLevel_arg | png compression level (default compression: -1)
  [in] | bShowStatistics_arg | show statistics

Definition at line 65 of file organized_pointcloud_compression.hpp.

References pcl::io::encodeMonoImageToPNG(), and pcl::io::encodeRGBImageToPNG().

## encodeRawDisparityMapWithColorImage()

template<typename PointT >

void pcl::io::OrganizedPointCloudCompression< PointT >::encodeRawDisparityMapWithColorImage | ( | std::vector< std::uint16_t > & | disparityMap_arg,
|  | std::vector< std::uint8_t > & | colorImage_arg,
|  | std::uint32_t | width_arg,
|  | std::uint32_t | height_arg,
|  | std::ostream & | compressedDataOut_arg,
|  | bool | doColorEncoding = `false`,
|  | bool | convertToMono = `false`,
|  | bool | bShowStatistics_arg = `true`,
|  | int | pngLevel_arg = `-1`,
|  | float | focalLength_arg = `525.0f`,
|  | float | disparityShift_arg = `174.825f`,
|  | float | disparityScale_arg = `-0.161175f`
| ) |  |

Encode raw disparity map and color image.

Note
  Default values are configured according to the kinect/asus device specifications

Parameters

  [in] | disparityMap_arg | pointer to raw 16-bit disparity map
  [in] | colorImage_arg | pointer to raw 8-bit rgb color image
  [in] | width_arg | width of disparity map/color image
  [in] | height_arg | height of disparity map/color image
  [out] | compressedDataOut_arg | binary output stream containing compressed data
  [in] | doColorEncoding | encode color information (if available)
  [in] | convertToMono | convert rgb to mono
  [in] | pngLevel_arg | png compression level (default compression: -1)
  [in] | bShowStatistics_arg | show statistics
  [in] | focalLength_arg | focal length
  [in] | disparityShift_arg | disparity shift
  [in] | disparityScale_arg | disparity scaling

Definition at line 159 of file organized_pointcloud_compression.hpp.

References pcl::io::encodeMonoImageToPNG(), and pcl::io::encodeRGBImageToPNG().

The documentation for this class was generated from the following files:

- pcl/compression/organized_pointcloud_compression.h
- pcl/compression/impl/organized_pointcloud_compression.hpp